//----------------------------------------------------------------
// http://ejohn.org/blog/simple-javascript-inheritance/
// Inspired by base2 and Prototype
(function(){
  var initializing = false, fnTest = /xyz/.test(function(){xyz;}) ? /\b_super\b/ : /.*/;

  // The base Class implementation (does nothing)
  this.Class = function(){};
 
  // Create a new Class that inherits from this class
  Class.extend = function(prop) {
    var _super = this.prototype;
   
    // Instantiate a base class (but only create the instance,
    // don't run the init constructor)
    initializing = true;
    var prototype = new this();
    initializing = false;
   
    // Copy the properties over onto the new prototype
    for (var name in prop) {
      // Check if we're overwriting an existing function
      prototype[name] = typeof prop[name] == "function" &&
        typeof _super[name] == "function" && fnTest.test(prop[name]) ?
        (function(name, fn){
          return function() {
            var tmp = this._super;
           
            // Add a new ._super() method that is the same method
            // but on the super-class
            this._super = _super[name];
           
            // The method only need to be bound temporarily, so we
            // remove it when we're done executing
            var ret = fn.apply(this, arguments);       
            this._super = tmp;
           
            return ret;
          };
        })(name, prop[name]) :
        prop[name];
    }
   
    // The dummy class constructor
    function Class() {
      // All construction is actually done in the init method
      if ( !initializing && this.init )
        this.init.apply(this, arguments);
    }
   
    // Populate our constructed prototype object
    Class.prototype = prototype;
   
    // Enforce the constructor to be what we expect
    Class.constructor = Class;

    // And make this class extendable
    Class.extend = arguments.callee;
   
    return Class;
  };
})();

//----------------------------------------------------------------
pathAbsLibs = pathAbsApp + "data/libraries/";

//----------------------------------------------------------------
// include your own library files here
//include(pathAbsLibs+"Class.js");
//include(pathAbsLibs+"Vector3.js");

//----------------------------------------------------------------
function include(pathFile,sketch)
{
    var s = readFile(pathFile);

    // Try to load from sketch folder first
    if (sketch && s=="")
        s = readFile(sketch.path + pathFile);
    // Try to load from libraries
    if (s=="")
        s = readFile(pathAbsLibs + pathFile);

    if (s!="")
    {
        println("- included "+pathFile);
        eval(s);
    }
    
}

//----------------------------------------------------------------
// https://developer.mozilla.org/en/SpiderMonkey/File_object
function readFile(pathFile)
{
	var s="";

	var file = new File(pathFile);
	if (file.exists && file.canRead && file.isFile)
	{
		file.open("read", "text");
		var lines = file.readAll();
		for each(line in lines)
			s+=line+"\n";
		file.close(); 
	}
	else
    {
//		println("- readFile error ..."+pathFile);	
	}

	return s;	
}

//----------------------------------------------------------------
function readLines(pathFile)
{
    lines=[];
	var file = new File(pathFile);
	if (file.exists && file.canRead && file.isFile)
	{
		file.open("read", "text");
		lines = file.readAll();
        file.close();
        return lines
    }
    return lines;
}

//----------------------------------------------------------------
function trim(s)
{
    return s.replace(/^\s+/g,'').replace(/\s+$/g,'') 
}

//----------------------------------------------------------------
function __TestABCD()
{
    this.xxxx = "toto";
}

/*function ofLVSketch(){
}
*/
ofLVSketch.prototype = new __TestABCD();
//var mySketch = new ofLVSketch();

println("ofLVSketch.prototype="+ofLVSketch.prototype);
println("ofLVSketch.prototype.xxxx="+ofLVSketch.prototype.xxxx);
//println("mySketch.mouseX="+mySketch.mouseX);
//println("mySketch.xxxx="+mySketch.xxxx);
