// traveller.js



//--------------------------------------------------------------
function setupOnce(){
    // libraries
    include("Vector3.js",this);
//    include("Particle.js",this);

    // window
	of.SetWindowTitle("LiveCoding / font / traveller.js");
	of.SetWindowShape(800, 600);
    of.SetRectMode(1);

    // font
	this.myFont = new ofxJSTrueTypeFont();
	this.myFont.loadFont(this.path+"Helvetica.ttf",160);

    // chars
    this.char = new Array();
    this.char.push(new CharParticle(this.myFont.getCharacterAsPoints(90),this));
    /*    for (i=65;i<65+26;i++)
        this.char.push(new CharParticle(this.myFont.getCharacterAsPoints(i)))
*/
}
//--------------------------------------------------------------
function setup(){
}

//--------------------------------------------------------------
function update()
{
    this.char[0].update();
}

//--------------------------------------------------------------
function draw()
{
	of.Background(0,0,0);
    of.SetColor(255,255,255);
    of.Translate(of.GetWidth()/2,of.GetHeight()/2,0);
    this.char[0].draw();
}

//--------------------------------------------------------------
function mouseMoved(x,y)
{
}

//--------------------------------------------------------------
function drawChar(char)
{
    for each(contour in char.contours){
        var pt  = null;
        var ptNext  = null;
        var nbPts   = contour.pts.length;

        gl.Begin(GL_LINE_STRIP);
        for (i=0;i<=nbPts;i++){
                pt = contour.pts[i%nbPts];
                gl.Vertex2(pt.x,pt.y);
            }
        gl.End();

    }
}



//--------------------------------------------------------------
function CharParticle(char,parent)
{
    this.parent = parent;
    this.char = char;
    this.particles = new Array();
    for (i=0;i<char.contours.length;i++){
        var p = new Particle();
        p.set(of.RandomWidth(),of.RandomHeight(),0);
        p.setContour(char.contours[i]);

        this.particles.push(p);    
    }

    this.draw = function(){
        this.parent.drawChar(this.char);
        for each(p in this.particles)
            p.draw();
    }

    this.update = function(){
        for each(p in this.particles)
            p.update();
    }
}

//--------------------------------------------------------------
function Particle()
{
    this.p = new Vector3();
    this.pT = new Vector3();
    this.v = new Vector3();
    this.a = new Vector3();
    this.d = new Vector3();
    this.contour=null;
    this.indexPoint=0;
    // --------------------------------
    this.draw = function(){
        of.Rect(this.p.x,this.p.y,5,5);
    }
    // --------------------------------
    this.setContour = function(contour){
        this.contour = contour;
    }
    // --------------------------------
    this.update = function(){
        this.d.sub(this.pT,this.p);
        this.d.multiply(0.02);
        this.p.addSelf(this.d);

        if (this.p.distanceToSquared(this.pT) < 1){
            this.setTargetNextPoint();
        }
    }
    // --------------------------------
    this.setTargetNextPoint = function()
    {
        if (this.contour){
            var pt = this.contour.pts[this.indexPoint];
            this.setTarget(pt.x,pt.y,0);
            this.indexPoint = (this.indexPoint+1)%this.contour.pts.length;
        }
    }
    // --------------------------------
    this.set = function(x,y,z){
        this.p.init(x,y,z);
    }
    // --------------------------------
    this.setTarget = function(x,y,z){
        this.pT.init(x,y,z);
    }
}
