// glut/disco.js

//--------------------------------------------------------------
function setupOnce()
{
    this.width              = 800;
    this.height             = 600;
	this.mouseX 			= 0;
	this.mouseY 			= 0;
	this.angle				= 0;
	this.zCubes				= 0;
	this.zCubesTarget		= 0;
	this.isBlending			= true;
    this.scaleCube          = 1;
    this.sizeCube           = 10;
    
	of.SetWindowTitle("LiveCoding / disco.js");
	of.SetWindowShape(this.width,this.height);
}
 
//--------------------------------------------------------------
function update()
{
	this.angle += 0.3; 
	if (this.angle>=360)
		this.angle -= 360.0;
	this.zCubesTarget = 100 + this.mouseY/this.height*200;
	this.zCubes += (this.zCubesTarget-this.zCubes)*0.09;

}

//--------------------------------------------------------------
function setup()
{
}

//--------------------------------------------------------------
function draw()
{
	of.Background(0,0,0);


    gl.Disable(GL_DEPTH_TEST);
    of.EnableAlphaBlending();

	var nbx=6;
	var nby=6;
	var nbz=6;
	var w=1;
    
    this.sizeCube = 15;

    of.Translate(this.width/2,this.height/2,this.zCubes);
	of.Rotate(this.angle, 1,0,0);
    of.Translate(-this.sizeCube*nbx/2,-this.sizeCube*nby/2,-this.sizeCube*nbz/2);
	for (var i=0;i<nbx;i++)
		for (var j=0;j<nby;j++)
			for (var k=0;k<nbz;k++)
			{
					this.scaleCube = 1+Math.cos((this.angle*4+i*15+j*30+k*22)*Math.PI/180.0)*4;

					of.PushMatrix();			

						of.Translate(i*w*this.sizeCube,j*w*this.sizeCube,k*w*this.sizeCube);
						of.Rotate(this.angle*4,i/nbx,j/nby,k/nbz);
						of.Scale(this.scaleCube,this.scaleCube,this.scaleCube);

						of.SetColor(i/nbx*255,j/nby*255,k/nbz*255,50);

						this.drawCube();
				of.PopMatrix();			
			}
    
    of.DisableAlphaBlending();
}

//--------------------------------------------------------------
function drawCube()
{
    glut.SolidCube(this.sizeCube);
}


//--------------------------------------------------------------
function drawSphere()
{
    glut.SolidSphere(this.sizeCube,this.sizeCube,this.sizeCube);
}


//--------------------------------------------------------------
function mouseMoved(x,y)
{
	this.mouseX = x;
	this.mouseY = y;
}


