// tweening01.js
// 
// http://quasipartikel.at/projects/processing-js-libs/Tween/


//--------------------------------------------------------------
function setup()
{
    include("Tween.js"); 

	of.SetVerticalSync(true);
	of.EnableSmoothing();
	of.SetWindowTitle("LiveCoding / tweening01.js");
    of.SetWindowShape(500,500);

    this.font = new ofxJSTrueTypeFont();
    this.font.loadFont(this.path+"Helvetica.ttf",10);
    
    this.ellipseX = 0;
    this.ellipseY = 0;
    this.mouseX = 0;
    this.mouseY = 0;
    this.mouseTargetX = 0;
    this.mouseTargetY = 0;
    this.tweenX = new Tween(this, "ellipseX", Tween.elasticEaseInOut, 0, 250,  2);
    this.tweenY = new Tween(this, "ellipseY", Tween.elasticEaseInOut, 0, 250, 2);
}

//--------------------------------------------------------------
function update()
{
    this.tweenX.tick();
    this.tweenY.tick();
}

//--------------------------------------------------------------
function draw()
{
	of.Background(0,0,0);
    of.Circle(this.ellipseX,this.ellipseY,25);
    this.font.drawString("("+this.ellipseX+","+this.ellipseY+")",this.ellipseX+30,this.ellipseY);
}

//--------------------------------------------------------------
function mouseMoved(x,y)
{
	this.mouseX = x;
	this.mouseY = y;
}

//--------------------------------------------------------------
function mousePressed(btn)
{
    this.tweenX.start();
    this.tweenY.start();
}